-- Fubar Stuff

-- Use Special Events Generatet to Update Lists Stuff



CPalaFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0",  "AceEvent-2.0")
CPalaFu.hasIcon = "Interface\\Icons\\Spell_Holy_HolyBolt";
--FuDB
CPalaFu:RegisterDB("CPalaFuDB");

local tablet = AceLibrary("Tablet-2.0"); -- Helper Libs
local roster = AceLibrary("Roster-2.1");

--Saved Vars
local countNeed = 0;
local countBuffed = 0;
local countFaded = 0;
local sealText = "";

local fubarOpt = {
	type = 'group',
    name = 'FuBar Plugin',
	desc = 'Set FuBar Plugin Options',
	order = 41,
	args = {
		buff = {			
			type = 'toggle',
			name = 'Tooltip Buff List',
			desc = 'Enable/Disable Buff List in Tooltip',
			get = function() return CPala.db.char.fu.buff end,
			set = function(value) CPala.db.char.fu.buff = value end,
			order = 1,
		},
		greater = {			
			type = 'toggle',
			name = 'Tooltip Greater Buff Need List',
			desc = 'Enable/Disable Greater Buff Need List in Tooltip',
			get = function() return CPala.db.char.fu.greater end,
			set = function(value) CPala.db.char.fu.greater = value end,
			order = 2,
		},
		need = {			
			type = 'toggle',
			name = 'Tooltip Buff Need List',
			desc = 'Enable/Disable Buff Need List in Tooltip',
			get = function() return CPala.db.char.fu.need end,
			set = function(value) CPala.db.char.fu.need = value end,
			order = 3,
		},
		ignore = {			
			type = 'toggle',
			name = 'Tooltip Ignore List',
			desc = 'Enable/Disable Ignore List in Tooltip',
			get = function() return CPala.db.char.fu.ignore end,
			set = function(value) CPala.db.char.fu.ignore = value end,
			order = 4,
		},
		text = {
			type = 'text',
			name = 'Info Text',
			desc = 'Set the Text to Display in FuBar, Replaces : %b - buffed Count %f - faded Count %n - need Count %s - Seal Box Text',
			get = function() return CPala.db.char.fu.text end,
			set = function(value) CPala.db.char.fu.text = value end,
			usage = '<string>',
			order = 10,
		},
	},
};

function CPalaFu:OnInitialize()	
	--Icon
	self.hasIcon = "Interface\\Icons\\Spell_Holy_HolyBolt";	
	--No Color in Tooltip
	self.hasNoColor = true;
	--No Profile
	--self.independentProfile = false;
	--Ignore/Unignore / Remove Tooltip Clicks
	self.clickableTooltip = true;	
	--Set Menu
	self.OnMenuRequest = CPala.cbuffcmd;		
	--Minimap
	self.defaultMinimapPosition = 240;
	
	self.OnMenuRequest.args.fu = fubarOpt;

	-- Build Fubar Menu
	local args = AceLibrary("FuBarPlugin-2.0"):GetAceOptionsDataTable(CPalaFu)
	for k,v in pairs(args) do
		if fubarOpt.args[k] == nil then
			fubarOpt.args[k] = v
		end
	end
	
	--Deativate Fubar Option
	args = AceLibrary("AceDB-2.0"):GetAceOptionsDataTable(CPalaFu)	
	fubarOpt.args.standby = args.standby;
	fubarOpt.args.standby.desc = "Suspend/Enable FuBar Plugin";
	fubarOpt.args.standby.handler = CPalaFu;

end;

	
function CPalaFu:OnEnable()
	self:RegisterEvent("CPALA_UPDATE_LIST", "UpdateTooltip"); -- directly Tooltip Update
	self:RegisterEvent("CPALA_UPDATE_SUMMARY");
	

end	

function CPalaFu:OnDisable()		
	--nothing
end


--Tooltip
function CPalaFu:OnTooltipUpdate()	
	
	tablet:SetHint("Click to Refresh List; Click Buff Entry to Remove; Click Need Entry to Ignore; Hover Any Entry to cast with Auto Buff Key (ooc only)");
		
	local none = CPala.none; -- local copy
	local shortcuts = CPala.shortcuts;
	local needList = CPala.needList;	
	local defaultBlessings = CPala.db.char.defaultBlessings;
	local classList = CPala.classList;	
	local selfbuff = CPala.selfbuff;	
	local EnterListNeed = self.EnterListNeed;
	local ClickListBuff = self.ClickListBuff;	
	local ClickListNeed = self.ClickListNeed;
	local EnterListBuff = self.EnterListBuff;
	local NoClickFunc = self.NoClickFunc;
	local fuDB = CPala.db.char.fu;
	local t = time(); -- curent time
	
	if (fuDB.buff) then
	-- first cat
    local cat = tablet:AddCategory(
        'id', 'Buffs',
		'columns', 3		
    )  
	--Topic
	cat:AddLine(
		'text', 'Lasting Buffs'
	);		
	--BuffList
	local text1, text2;
	for target, entry in pairs(CPala.buffList) do
		-- Faded? / Time
		if entry[4] then
			text1 = 'Faded';
		else
			text1 = CPala:FormatSeconds(entry[3] - (t - entry[2]));
		end
		
		local name;
		if classList[target] then
			name = entry[5];
			text2 = classList[target];
		else
			name = target;
			text2 = target;
		end;
		
		--[[
		if entry[5] == 1 then
			text2 = text2 .. "(friend)";
		elseif entry[5] == 2 then
			text2 = text2 .. "(pet)";
		end;
		]]
		
		text2 = text2 .. CPala:GetBuffTypeText(entry[5]);
		
		cat:AddLine(
			'text', text2,
			'text2', shortcuts[entry[1]],
			'text3', text1,
			'func', ClickListBuff,
			'arg1', self,
			'arg2', target,
			'onEnterFunc', EnterListBuff,
			'onEnterArg1', self,
			'onEnterArg2', name,
			'onEnterArg3', entry[1]
		);					
	end;	
	end;
	
	if (fuDB.greater) then
	local cat = tablet:AddCategory(
        'id', 'Buffs',
		'columns', 2
    )
	
	--Topic	
	cat:AddLine(
		'text', 'Greater Needs'
	);
		
	--Needlist	
	--Class
	for class, count in pairs(CPala.greaterCount) do
		if count > 0 then			
			local obj, name, buff;			
			buff = defaultBlessings[class];	
			name = class;
			for key, entry in pairs(needList) do
				-- Search for first avilabe Player of this class to change current need & co
				obj = roster:GetUnitObjectFromName(key);
				if (obj and (obj.class == class) and (entry[1] == buff)) then			
					name = obj.name;
					break;
				end;	
			end;			
			
			cat:AddLine(
				'text', classList[class],
				'text2', format("%s x%i", shortcuts[defaultBlessings[class]], count),
				'func', NoClickFunc,
				'onEnterFunc', EnterListNeed,
				'onEnterArg1', self,
				'onEnterArg2', name 
				);
		end;
	end;
	end;

	if (fuDB.need) then
	local cat = tablet:AddCategory(
        'id', 'Buffs',
		'columns', 2
    );
	--Topic
	cat:AddLine(
		'text', 'Single Needs'		
	);
	--Single	
	for target, entry in pairs(needList) do
		--List Only Reald Needs and None Group Buffs  
		if (not entry[4]) and (entry[1] ~= none) and ((not entry[2]) or (target == selfbuff) or entry[3]) then		
			if (entry[3]) then  -- if overbuffed
				text1 = format("(%s)",shortcuts[entry[1]]);
			else
				text1 = shortcuts[entry[1]];
			end;		
			cat:AddLine(
				'text', target,
				'text2', text1,	
				'func', ClickListNeed,
				'arg1', self,
				'arg2', target,
				'onEnterFunc', EnterListNeed,
				'onEnterArg1', self,
				'onEnterArg2', target 
			);						
		end;						
	end;	
	end;
	
	if (fuDB.ignore) then
	local cat = tablet:AddCategory(
        'id', 'Buffs',
		'columns', 1
    );
	--Topic
	cat:AddLine(
		'text', 'Ignored Players'		
	);
	for target, entry in pairs(needList) do
		--List Only Reald Needs and None Group Buffs  
		if (entry[4])  then		
			cat:AddLine(
				'text', target,				
				'func', ClickListNeed,
				'arg1', self,
				'arg2', target				
			);						
		end;						
	end;
	end;
end;


--****Tooltip Click Functions

function CPalaFu:NoClickFunc()
	-- do nothing just to highlight on mouseover
end;

-- Buffed Clicked, remove from list
function CPalaFu:ClickListBuff(target)
	CPala:Msg(format("Removed Buff Time for %s", target));
	CPala.buffList[target] = nil;
	self:UpdateTooltip();
end;

-- Need List Clicked
function CPalaFu:ClickListNeed(target)	
	if (target == CPala.selfbuff) then
		obj = roster:GetUnitObjectFromName(UnitName("player"));
	else
		obj = roster:GetUnitObjectFromName(target);
	end;
	if (not obj) then
		CPala:Msg(format("Removed Need Entry for %s - not in Group", target));
		CPala.needList[target] = nil;
		self:UpdateTooltip();
		return;
	end;

	local entry = CPala.needList[target];
	if entry then
		entry[4]  = not entry[4];
		if (entry[4]) then
			CPala:Msg(format("Now Ignore Buff Need for %s", target));
		else
			CPala:Msg(format("Now List Buff Need for %s again", target));
		end;
		self:UpdateTooltip();
	end;
end;

-- Hover Need List Entry
function CPalaFu:EnterListNeed(target)		
	if (not CPala.needbox) then
		return  --just for safety
	end;
	
	local obj; -- Get Unit Information
	local show = CPala.needList[target];
	local box = CPala.needbox.box;
	
	if (target == CPala.selfbuff) then
		obj = roster:GetUnitObjectFromName(UnitName("player"));
	else
		obj = roster:GetUnitObjectFromName(target);
	end;
	
	if (obj) and (show) then
		local text;			
		text = format("Buff %s on %s", CPala.shortcuts[show[1]], target);		
		if (show[2]) then
			-- if greater buff add small buff as right click
			CPala:SetNeedBoxConfig(text, "spell", obj.unitid, show[1], strsub(show[1], 9) );			
		else -- else double normal
			CPala:SetNeedBoxConfig(text, "spell", obj.unitid, show[1], show[1]);			
		end;		
	else		
		CPala:SetNeedBoxConfig("Unit not avilable to target!", "update", nil, nil, nil );				
	end;		
end;

-- Hover Buff Entry
function CPalaFu:EnterListBuff(target, spell)		
	if (not CPala.needbox) then
		return  --just for safety
	end;
	
	local obj;
	local box = CPala.needbox.box;
	
	if (target == CPala.selfbuff) then
		obj = roster:GetUnitObjectFromName(UnitName("player"));
	else
		obj = roster:GetUnitObjectFromName(target);
	end;	
		
	if (obj)  then		
		CPala:SetNeedBoxConfig(format("Rebuff %s on %s", CPala.shortcuts[spell], target), "spell", obj.unitid, spell, spell );			
	else		
		CPala:SetNeedBoxConfig("Unit not avilable to target!", "update", nil, nil, nil );			
	end;	
end;

function CPalaFu:CPALA_UPDATE_SUMMARY(need, buff, fade, seal)
	--Update Local Vars
	countNeed = need or countNeed;
	countBuffed = buff or countBuffed;
	countFaded = fade or countFaded;
	sealText = seal or sealText;
	self:UpdateText(); -- Update Text
end;

--Update Fubar Text
function CPalaFu:OnTextUpdate()
	local text = CPala.db.char.fu.text;
	text = string.gsub(text, "%%b", countBuffed);
	text = string.gsub(text, "%%f", countFaded);
	text = string.gsub(text, "%%n", countNeed);
	text = string.gsub(text, "%%s", sealText);
	self:SetText(text);
end;

--On Click Fubar Text
function CPalaFu:OnClick()
	CPala:CheckBuffTime();
	CPala:CheckBuffNeed(true); -- On Click Update Need List 
end;
