

local commPrefix = "PLPWR";
local roster = AceLibrary("Roster-2.1");
local player;


--Translation Tables for PallyPower Codes
local ClassID = { 
	[1] = "WARRIOR",
	[2] = "ROGUE",
	[3] = "PRIEST",
	[4] = "DRUID",
	[5] = "PALADIN",
	[6] = "HUNTER",
	[7] = "MAGE",
	[8] = "WARLOCK",
	[9] = "SHAMAN",
	[10] = "PET"};
	

local IdToSpell = {
	["n"] = CPala.none,
	[0] = CPala.none,
	[1] = "Greater Blessing of Wisdom",
	[2] = "Greater Blessing of Might",
	[3] = "Greater Blessing of Salvation",
	[4] = "Greater Blessing of Light",
	[5] = "Greater Blessing of Kings",
	[6] = "Greater Blessing of Sanctuary",
	};
	
local SpellToId = {
	[CPala.none] = 0,

	["Greater Blessing of Wisdom"] = 1,
	["Greater Blessing of Might"] = 2,
	["Greater Blessing of Salvation"] = 3,
	["Greater Blessing of Light"] = 4,
	["Greater Blessing of Kings"] = 5,
	["Greater Blessing of Sanctuary"] = 6,
	
	["Blessing of Wisdom"] = 1,
	["Blessing of Might"] = 2,
	["Blessing of Salvation"] = 3,
	["Blessing of Light"] = 4,
	["Blessing of Kings"] = 5,
	["Blessing of Sanctuary"] = 6,
	
};

--local store of other pallys assigns
local assigns =  {
	--[[ ["name"] = {
		["class"] = "buff short",
	}]]	
};	
	
	
function CPala:InitPally()

end;


function CPala:EnablePally()
	self:RegisterEvent("CHAT_MSG_ADDON");
	player = UnitName('player');
end;


function CPala:PallySendMessage(msg)   
    local type;
    if GetNumRaidMembers() == 0 then
		type = "PARTY";
    else
		type = "RAID";
    end
	--self:Print("Sending " .. msg);
    SendAddonMessage(commPrefix, msg, type);
end

function CPala:PallyCheckRaidLeader(nick)
	local obj = roster:GetUnitObjectFromName(nick);
	if not obj then
		return false
	end;
	if obj.rank > 0 then
		return true;
	end;
	return false
end

function CPala:CHAT_MSG_ADDON(prefix, msg, distribution, sender)	
	if prefix == commPrefix and (distribution == "PARTY" or distribution == "RAID") then		
		
		
		if sender == player then
			--dont parse our one messages!
			return;	
		end;

		--we need to report our status
		if msg == "REQ" then			
			self:PallySendSelf();
			for name, _ in pairs(assigns) do
				--remove member no longer in group
				if not roster:GetUnitObjectFromName(name) then
					assigns[name] = nil;
				end;
			end;
			return;
		end;

		--sym count report, used to see how is in the channel ...
		if string.find(msg, "^SYMCOUNT") then
			if not assigns[sender] then
				--request unkonw member
				self:PallySendMessage("REQ");	    
			end;								
			return;
		end
	
		local shortcuts = self.shortcuts;
		
		--someone reports status
		if string.find(msg, "^SELF") then
			--parse message
			local _, _, _, assign = string.find(msg, "SELF ([0-9n]*)@([0-9n]*)")
						
			if assign then
				--local report = ""; --debug
				local tmp;
								
				if not assigns[sender] then
					assigns[sender] = {};
					self:Print("PallyPower User found : " .. sender);
				end;				
				
				--read blessing settings
				for i = 1, 10 do
					tmp = string.sub(assign, i, i); --get one number each	
					if tmp ~= "n" then
						tmp = tmp + 0;
					end;
					--report = string.format("%s; On %s %s", report, ClassID[i], shortcuts[IdToSpell[tmp]]);
					assigns[sender][ClassID[i]] = shortcuts[IdToSpell[tmp]];   -- change local copy of this fact ;)
					self:PallyUpdateTooltip(ClassID[i]);
				end
								
				--self:Print(sender .. " has settings : " .. report);
			end
			return;
		end;
				
		local leader = self:PallyCheckRaidLeader(sender)
		local defaultBlessings = self.db.char.defaultBlessings;
		
		--a buffed getting assigend
		if string.find(msg, "^ASSIGN") then
			local _, _, name, class, skill = string.find(msg, "^ASSIGN (.*) (.*) (.*)")
			
			if not name == sender and not leader then 
				return false 
			end;			
			
			class = class + 0;
			
			if (skill == "n") then
			
			else
				skill = skill + 0;
			end;
					
			
			if (not assigns[name]) and (not name == player) then
				self:SendMessage("REQ");
			else
				if (name == player) then
					class = ClassID[class];
					skill = IdToSpell[skill];
					--[[if ClassID[class] == "PET" then	
						--fix this ;)
						self:Print(string.format("%s want you to buff %s on Pets (not supported)", sender, shortcuts[IdToSpell[skill] ]));
						return;
					end;]]
					self:Print(string.format("%s changed your %s buff to %s", sender, class, shortcuts[skill]));
					
					defaultBlessings[class] = skill;
					
					if self.buffList[class] then
						-- fake faded old buff
						if self.buffList[class][1] ~= skill then
							self.buffList[class][4] = true
							self.buffList[class][1] = self.none;
						end;
					end; 
					CPala:CheckBuffTime();
					CPala:CheckBuffNeed(); 				
				else							
				--[[debug	if (not assigns[name]) then
						self:Print("Unkown name" .. name);
					end;
					if (not ClassID[class]) then
						self:Print("Unkown class " .. class);
					end;
					if (not IdToSpell[skill]) then
						self:Print("Unkown skill " .. skill);
					end;  ]]
					
					if (not assigns[name]) then
						assigns[name] = {}
					end;
					
					assigns[name][ClassID[class]] = shortcuts[IdToSpell[skill]];
					self:PallyUpdateTooltip(ClassID[class]);
					
				end;
			end;
						
			--[[ if name == player then
				self:Print(string.format("You should change for %s to %s", ClassID[class], shortcuts[IdToSpell[skill] ]));
			else
				self:Print(string.format("%s buff for %s changed to %s", name, ClassID[class], shortcuts[IdToSpell[skill] ]));
			end; ]]
			return;
		end

		--all buffs in one 
		if string.find(msg, "^MASSIGN") then
			local _, _, name, skill = string.find(msg, "^MASSIGN (.*) (.*)")
			if not name == sender and not leader then return false end;			
			skill = skill + 0;
			
			
			if (not assings[name]) and (not name == player) then
				self:SendMessage("REQ");
			else
				if name == player then
					self:Print(string.format("%s changed all your buffs to %s", sender,  shortcuts[IdToSpell[skill]]));
					for value, _ in pairs(self.classList) do
						defaultBlessings[value] = IdToSpell[skill];					
					end;														
					CPala:CheckBuffTime();
					CPala:CheckBuffNeed(); 				
				else
					for value, _ in pairs(self.classList) do
						assigns[name][value] = shortcuts[IdToSpell[skill]];
						self:PallyUpdateTooltip(value)
					end;					
				end;
			end;
			
			
			if name == player then
				self:Print(string.format("You should change all to %s", name, shortcuts[IdToSpell[skill]]));
			else
				self:Print(string.format("%s buff for all changed to %s", name, shortcuts[IdToSpell[skill]]));
			end;
			return;
		end
		 
    end
end;

function CPala:PallySendSelf()
	local s;
	
	local db = self.db.char; -- Local Copy
	
	--simulate blessing ranks + talent ranks
	s = "SELF 30201020"  --  1020@";
	if (db.menu.bok) then	
		s = s .. "10";
	else
		s = s .. "nn";
	end;
		
	if (db.menu.bosa) then
		s = s .. "20";
	else
		s = s .. "nn";
	end;
	s = s .. "@";
	
	--after ranks comes your blessing settings
	local defaultBlessings = self.db.char.defaultBlessings;
	s = s .. SpellToId[defaultBlessings["WARRIOR"] ];
	s = s .. SpellToId[defaultBlessings["ROGUE"] ];
	s = s .. SpellToId[defaultBlessings["PRIEST"] ];
	s = s .. SpellToId[defaultBlessings["DRUID"] ];
	s = s .. SpellToId[defaultBlessings["PALADIN"] ];
	s = s .. SpellToId[defaultBlessings["HUNTER"] ];
	s = s .. SpellToId[defaultBlessings["MAGE"] ];
	s = s .. SpellToId[defaultBlessings["WARLOCK"] ];
	s = s .. SpellToId[defaultBlessings["SHAMAN"] ];
	s = s .. SpellToId[defaultBlessings["PET"] ];
	self:PallySendMessage(s);
end;

function CPala:PallyReportChange(class, buff)		
	--enabled?
	if not self.db.char.pallypower then
		return;
	end; 
	
	local classid;
	--class to id
	for id, value in pairs(ClassID) do
		if value == class then
			classid = id
			break;
		end;
	end;	
	if classid then
		self:PallySendMessage(string.format("ASSIGN %s %i %i", player, classid, SpellToId[buff]));
	end;
end;

function CPala:PallyUpdateTooltip(class)
	local menu = self.cbuffcmd.args;
	local new;
	local defaultBlessings = self.db.char.defaultBlessings;
	if menu[self.classList[class]] then
		new = "PallyPower Data:";
		for name, buffs in pairs(assigns) do
			if buffs[class] then
				new = string.format("%s\nPala %s buffing %s", new, name, buffs[class]);								
			end;
		end;
		menu[self.classList[class]].desc = new;
	end;
end;


