-- Seal Box and Cleanse Reminder Stuff

--Auras on Target
local noSeal = true;
local lastCleanse; -- limit message spam

CPala.sealbox = true;

function CPala:InitSealBox()
	-- Create the Seal Mesage box
	local db = self.db.char;
		
	local box = CLibBox:CreateBox("CPalaSealBox", nil);	
	CLibBox:MakeBoxDragable(box,  
		function (x, y)
			db.sealBox.x = x;
			db.sealBox.y = y;
		end, 
		"LeftButton", "RightButton");
	box:SetText("None");
	box:SetSize(120, 18);						
	box:SetPos(db.sealBox.x, db.sealBox.y);
					
	box:SetBorderVisible(db.boxBorder);
	box:Show();
	if (db.boxLock) then
		box:Lock();
	else
		box:Unlock();
	end;
	self.sealbox = box;
end;

function CPala:EnableSealBox()
	self:RegisterEvent("PLAYER_AURAS_CHANGED");
	--self:RegisterEvent("PLAYER_TARGET_CHANGED", "PLAYER_AURAS_CHANGED");
	self:RegisterEvent("PLAYER_ENTER_COMBAT", "PLAYER_AURAS_CHANGED");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT", "PLAYER_AURAS_CHANGED");	
	self:ScheduleRepeatingEvent(self.CheckTargetDebuffs, 1, self);
	lastCleanse = time();
end;

function CPala:CheckTargetDebuffs()		
	if UnitExists("target") and UnitCanAttack("player", "target") then
		if (noSeal) then
			return;
		end;		
		local text;
		local i = 1;
		local buff_name, _, _, count, _, dur, left  = UnitDebuff("target", i, true); -- we can cleanse our own debuff ...
		local short;
		while (buff_name) and (dur) do							
			short = self.shortcuts[buff_name];
			if short then								
				if (text) then					
					text = format("%s; %s", text, short);
				else
					text = short;
				end;
				if (count > 0) then
					text = format("%s_%i", text, count);
				end;
				if (left) and (left > 0) then
					text = format("%s(%i)", text, left);
				end;		
			end;
			i = i + 1;
			buff_name, _, _, count, _, dur, left = UnitDebuff("target", i, true);
		end;
		if (text) then			
			self.sealbox:Show();			
			self.sealbox:SetText(text);		
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, text);			
			return true;
		else			
			self.sealbox:Hide();			
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");			
			return false;
		end;
	end;	
end;


function CPala:SealBoxAura(unit)	
	--[[if (unit == "target") then		
		if (noSeal) then
			return;
		end;
		local sealbox = self.sealbox;
		local text;
		local i = 1;
		local buff_name, rank, icon, count, dur, left  = UnitDebuff("target", i, true); -- we can cleanse our own debuff ...
		local short;
		while (buff_name) do	
			short = self.shortcuts[buff_name];
			if short then								
				if (text) then					
					text = format("%s; %s", text, short);
				else
					text = short;
				end;
				if (count > 0) then
					text = format("%s_%i", text, count);
				end;
				if (left) and (left > 0) then
					text = format("%s(%i)", text, left);
				end;
			end;
			i = i + 1;
			buff_name, rank, icon, count, dur, left = UnitDebuff("target", i, true);
		end;
		if (text) then
			sealbox:Show();
			sealbox:SetText(text);		
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, text);			
		else
			sealbox:Hide();			
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");			
		end;
	-- Range Check longer then actuall distance ;)
	else]] if UnitCanAssist(unit, "player") and UnitDebuff(unit, 1, true) and (IsSpellInRange("Flash of Light", unit) ~= 0) then
		local t = time();
		if (t - lastCleanse) > 5 then
			lastCleanse = t;
			--Message
			local text = format("***Need Cleanse*** (%s)", UnitName(unit));
			UIErrorsFrame:AddMessage(text);
			ChatFrame2:AddMessage(text);
		end
	end;	
end;

function CPala:PLAYER_AURAS_CHANGED()
	local sealbox = self.sealbox;
	local noAura = true;
	noSeal = true;
	
	--check buffs for seal/aura
	local i = 1;
	local buff_name = UnitBuff("player", i, false);
	while (buff_name) do
		if strfind(buff_name, "Aura") then
			noAura = false;										
		end;
		if strfind(buff_name, "Seal") then
			noSeal = false;									
		end;
		i = i + 1;
		buff_name = UnitBuff("player", i, false);
	end;
	
	--No Aura show always
	if noAura then
		noSeal = true;
		sealbox:Show();		
		sealbox:SetText("No Aura!");			
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "No Aura!");	
		return;
	end
	
	--check if target, target attackable, and currently attacking ;)
	if (not UnitExists("target")) or (not UnitCanAttack("player", "target")) or (not IsCurrentAction(1)) then
		sealbox:Hide();		
		noSeal = false;
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");	
		return;
	end;
	
	if noSeal then
		sealbox:Show();
		sealbox:SetText("No Seal!");	
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "No Seal!");				
		return;
	else		
		if not self:CheckTargetDebuffs() then
			sealbox:Hide();
		end;
	end;
	
	--[[if (not UnitCanAttack("player", "target")) then
		sealbox:Hide();		
		noSeal = false;
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");	
		return;
	end;]]
	
	
	
--[[	if (IsCurrentAction(1)) then
		local i = 1;
		local buff_name = UnitBuff("player", i, false);
		while (buff_name) do
			if strfind(buff_name, "Seal") then
				noSeal = false;				
				if not self:CheckTargetDebuffs() then
					sealbox:Hide();
				end
					--self:SealBoxAura("target");
				return;
			end;
			i = i + 1;
			buff_name = UnitBuff("player", i, false);
		end;
		sealbox:Show();
		sealbox:SetText("No Seal!");	
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "No Seal!");			
		noSeal = true;
	else
        noSeal = false;
		self:CheckTargetDebuffs();
		--self:SealBoxAura("target");
	end;
	
	]]
end;